<?php



/**
 * Scalar version 15.2.10 - install
 *
 * @author Reclaim Hosting
 */
class i_scalar_2_0_1_install extends i_action_install
{	//==========================================================================
	// STEP I: INTERNAL CONFIGURABLES
	//==========================================================================
		
	public function step1_init()
	{
		$this->setStepLabel("_step_progress_settings");
		$this->setInputFields(array(
		   		array(
		   			"ID" => "fullname",
		   			"LABEL" => "Full Name",
		   			"TYPE" => "text",
		   			),
		         array(
		   			"ID" => "passwd",
		   			"LABEL" => "Password",
		   			"TYPE" => "password",
		   			),
		   	 ));
		}
		
	public function step1_process()
	{
		// TIP: error checking for custom inputs can be added here
	}
		
	//==========================================================================
	// STEP II: ARCHIVE EXTRACTION
	//==========================================================================
		
	public function step2_init()
	{
		$this->setStepLabel("_step_progress_extracting");
	}
		
	public function step2_process()
	{
		// extract the 'main' archive:
		$this->extract("main");
		       $this->extract("transfer");
	}
		
	//==========================================================================
	// STEP III: CONFIGURING INSTALL
	//==========================================================================
		
	public function step3_init()
	{
		$this->setStepLabel("_step_progress_processing");
	}
		
	public function step3_process()
	{
		   $this->mv('scalar-2.0.1/*');
		   $this->mv('transfer-tool-2.0.1/*','system/application/plugins/transfer/');
		   $this->write(".htaccess","Options +FollowSymlinks
		
	RewriteEngine On
		
	# Scalar pages have default views that are called when a URI has no file extension
	# Turn off the MultiView option (if it's on) so it doesn't conflict
	Options -MultiViews
		
	# To route all requests to a maintenance page, uncomment these lines
	#RewriteCond %{REQUEST_FILENAME} !maintenance.html [NC]
	#RewriteRule (.*) maintenance.html [L]
		
	# To route the home page (book index) to some place else, uncomment these lines
	#RewriteCond %{REQUEST_FILENAME} ^/Library/WebServer/scalar\.usc\.edu/anvc/index\.php$
	#RewriteRule (.*) /Library/WebServer/scalar.usc.edu/anvc_site/ [L]
	#RewriteCond %{REQUEST_FILENAME} ^/Library/WebServer/scalar\.usc\.edu/anvc/$
	#RewriteRule (.*) /Library/WebServer/scalar.usc.edu/anvc_site/ [L]
		
	# Route to codeigniter if file or directory doesn't exist
	RewriteCond %{REQUEST_FILENAME} !codeigniter.php [NC]
	RewriteCond %{REQUEST_FILENAME} !-d
	RewriteCond %{REQUEST_FILENAME} !-f
	RewriteRule (.*) codeigniter.php/$1 [L]
	RewriteRule ^$ codeigniter.php [L]
		
	# If a directory, don't send to codeigniter if it's the root folder
	# the server in turn will add the trailing slash and things are back to normal
	# This is to overcome what appears to be an old server setting on Vectors
	# and/or not being able to change DirectorySlash
	RewriteCond %{REQUEST_FILENAME} !codeigniter.php [NC]
	RewriteCond %{REQUEST_FILENAME} -d
	RewriteRule ^/(.*)$ - [L]
		
	# Pass through directory
	RewriteCond %{REQUEST_FILENAME} !codeigniter.php [NC]
	RewriteCond %{REQUEST_FILENAME} -d
	RewriteRule (.*) codeigniter.php/$1 [L]
		
	");
		$this->rm('scalar');
		       $this->rm('transfer-tool-2.0.1');
		$this->db_import('system/application/config/scalar_store.sql');
		
		$shasalt = i_lib::randstr(32);
		 	$password = hash('sha512', $this->input['field_passwd'] . $shasalt);
		
		$sql .= "INSERT INTO `scalar_db_users` (`user_id`, `email`, `fullname`, `password`, `reset_string`, `url`, `is_super`) VALUES (1,'".$this->db_escape($this->input["field_email"])."','".$this->db_escape($this->input["field_fullname"])."','".$this->db_escape($password)."','','',1);\n";
		$this->write("install.sql",$sql);
		$this->db_import("install.sql");
		$this->rm("install.sql");
		
		$this->sr("system/application/config/database.php", array(
		              "#\['default']\['username'] = ''#" => "['default']['username'] = ".var_export($this->db_user,true),
		              "#\['default']\['password'] = ''#" => "['default']['password'] = ".var_export($this->db_pass,true),
		              "#\['default']\['database'] = ''#" => "['default']['database'] = ".var_export($this->db_user,true),
		));
		   $this->sr("system/application/config/local_settings.php", "#config\['shasalt'] = ''#","config['shasalt'] = ".var_export($shasalt,true));
		$this->sr("system/application/config/config.php", array(
		  '#config\[\'encryption_key\'] = ""#' => 'config[\'encryption_key\'] = '.var_export(i_lib::randstr(32),true)
		));
	}
}



?>